// Public domain by Sam Trenholme 2013

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

// Random number generator http://samiam.org/rg32/
#define rgp uint32_t 
#define rgf(a) for(c=0;c<a;c++){
#define rgn w[c*13]^=s;u[16+c]^=s;
void rgk(rgp*a,rgp*b){rgp m=19,A[19],x,o=13,c,y,r,q[3];rgf(3)y=c*o;q[c
]=b[y+12];for(r=o;--r;)b[y+r]=b[y+r-1];b[y]=q[c];}rgf(12)b[c+1+c%3*o]
^=a[c+1];}rgf(m)r+=c;y=c*7%m;r&=31;x=a[y]^(a[(y+1)%m]|~a[(y+2)%m]);A[
c]=x>>r|x<<(32-r);}rgf(m)a[c]=A[c]^A[(c+1)%m]^A[(c+4)%m];}rgf(3)a[c+o
]^=q[c];}*a^=1;}void rgl(rgp*u,rgp*w,char*v){rgp s,q,c,x;rgf(39)w[c]=
u[c%19]=0;}for(;;rgk(u,w)){rgf(3)for(s=q=0;q<4;){x=*v++;s|=(x?x:1)<<8
*q++;if(!x){rgn;rgf(17)rgk(u,w);}return;}}rgn;}}}rgp rgi(rgp*m,rgp*b)
{static int a=2;a&2?rgk(m,b):0;return m[a^=3];}
uint32_t belt[39], mill[19];

// Initialize the RNG (required)
void rng_init(char *seed) {rgl(mill,belt,seed);}

// Create a random seed based on the time
char *rng_make_seed() {
	char *out;
	out = malloc(100);
	if(out == NULL) {
		return 0;
	}
	snprintf(out,32,"time-%d",time(0));
	return out;
}

// Convert a 16-bit number in to a random seed string
char *rng_16_seed(uint16_t in) {
	char *out;
	out = malloc(5);
	if(out == NULL) {
		return 0;
	}
	out[0] = 'a' + ((in >> 12) & 0xf);
	out[1] = 'a' + ((in >> 8) & 0xf);
	out[2] = 'a' + ((in >> 4) & 0xf);
	out[3] = 'a' + (in & 0xf);
	out[4] = 0;
	return out;
}

// Return a random num between 0 and 65535
uint16_t rgNN(uint16_t n) {
	static uint32_t phase = 0,i;
	if(phase==0) {
		i = rgi(mill,belt);
		phase = 1;
		return i & 0xffff;
	} 
	i >>= 16;
	i &= 0xffff;
	phase = 0;
	return i;
}

// A random int between 0 and n - 1
int32_t rgNum(uint32_t n) {
        uint32_t top, c, z;

        if(n < 1) {
                n = 100;
        } else if(n > 65536) {
                n = 65536;
        }

        top = n * (65536 / n);
        c = top + 1;
        for(z = 0;z < 1000; z++) {
                c = rgNN(0);
                if(c < top) {
                        return c % n;
                }
        }
        return -1;
}

// A random 256-entry invertible s-box
uint8_t *make_sbox(uint16_t seed) {
	uint8_t *out;
	char *z;
	uint8_t v[256];
	int op = 0;
	uint8_t p = 0;
	out = malloc(256);
	if(out == NULL) {
		return out;
	}	
	z = rng_16_seed(seed);
	rng_init(z);
	free(z);
	for(op = 0; op < 256; op++) {
		v[op] = 0;
		out[op] = 0;
	}
	op = 0;
	while(op < 256) {
		p = (rgNN(0) & 0xff);
		if(v[p] == 0) {
			v[p] = 1;
			out[op] = p;
			op++;
		}
	}
	return out;
}

int32_t xar(int32_t r, int32_t a, int32_t b) {
        r ^= b;
        r += a;
        r &= 0xff;
        r = (r << 1) | (r >> 7);
        r &= 0xff;
        return r;
}

uint8_t galois_lfsr(uint8_t r, uint8_t taps, int direction) {
	uint8_t c, t;
	if(direction == 0) {
		c = r & 1; r >>= 1;				// lsr
	} else {
		c = r & 0x80; r <<= 1;				// asl
		taps <<= 1;
		taps |= 1;
	}
	if(c != 0) {						// bcc skipEor
		r ^= taps;
	}
	return r;
}

uint8_t *make_galois_lfsr_sbox(uint16_t taps, int n) {
	uint8_t *out;
	int op,v;
	int m, t;
	taps &= 0x7f;
	taps |= 0x80;
	out = malloc(256);
	printf("taps: %02x %d\n",taps,n);
	fflush(stdout); // Windows needs this
	for(op=0;op<256;op++) {
		m = n;
		v = op;
		t = taps;
		for(;m>0;m--) {
			v = galois_lfsr(v, t, 0);
			t+=3;
			t &= 0x7f;
			t |= 0x80;
		}
		out[op] = v;	
	}
	return out;
}

// xar-based 256-entry sbox
// n = 0: Use seed to run one XAR round
// n > 0: Additional xar rounds, using random constants derived from rg32
// r: Number of times to run XAR operations with same constants
uint8_t *make_xar_sbox(uint16_t seed, int n, int r) {
	int a, b;
	int *ap, *bp;
	uint8_t *out;
	int op = 0;
	int q, v, z;
	char *c;
	out = malloc(256);
	if(n > 0) {
		ap = malloc((n + 2) * sizeof(int));
		bp = malloc((n + 2) * sizeof(int));
		if(ap == NULL || bp == NULL) {
			return 0;
		}
	}
	if(out == NULL) {
		return 0;
	}	
	c = rng_16_seed(seed);
	rng_init(c);
	free(c);
	q = n;
	for(;q>0;q--) {
		ap[q] = (rgNN(0) & 0xff);
		bp[q] = (rgNN(0) & 0xff);
	}
	for(op=0;op<256;op++) {
		z = r;
		v = op;
		for(;z>0;z--) {
			a = seed & 0xff;
			b = (seed & 0xff00) >> 8;
			q = n;
			v = xar(v,a,b);
			for(;q>0;q--) {
				a = ap[q];
				b = bp[q];
				v = xar(v,a,b);
			}
		}
		out[op] = v;
	}
	// Show macig numbers on stdout
	a = seed & 0xff;
	b = (seed & 0xff00) >> 8;
	printf("a: %02x b: %02x\n",a,b);
	q = n;
	for(;q>0;q--) {
		printf("a: %02x b: %02x\n",ap[q],bp[q]);	
	}
	free(ap); free(bp);
	return out;
}

void stdout_sbox(uint8_t *sbox) {
	int a;
	// Show the sbox
	for(a = 0; a < 16; a++) {
		printf("_%1x ",	a);
	}
	printf("\n");
	for(a = 0; a < 16; a++) {
		printf("---",	a);
	}
	printf("\n");
	for(a = 0; a < 256; a++) {
		printf("%02x ",sbox[a]);
		if(a % 16 == 15) {printf("| %1x_\n",(a >> 4));}
	}
}

#ifndef MASK
#define MASK 0xff
#endif
#ifndef BITS
#define BITS 8
#endif
#ifndef NUM
#define NUM uint8_t
#endif

int view_cycles(NUM *sbox) {
	int32_t a, b, q, p, r, x, l, m, s, g;
	int32_t c[MASK + 1];
	int32_t t[MASK + 1];
	int32_t z[MASK + 1];
	int32_t k[MASK + 1];
	for(q=0;q<=MASK;q++) {
		c[q] = 0;
		t[q] = 0;
		z[q] = 0;
		k[q] = 0;
	}
	q = 1;
	x = 0;
	l = 0;
	s = MASK + 1;	
	g = 0;
	while(x <= MASK) {
		while(c[x] != 0 && x <= MASK) {
			x++;
		}
		if(x > MASK) {
			break;
		}
		r = x;
		p = 0;
		do {	
			if(c[r] == 0) {
				c[r] = q;
			} else if(r != x) {
				g = 1; // Has Garden of Eden
			}
			r = sbox[r];
			p++;
		} while(r != x && p < MASK + 1);	
		if(p > l) { l = p; }
		if(p < s) { s = p; }
		q++;
	}
	if(g == 0) {
	     printf(" periods %d - ",q - 1); // # periods
	     printf(" long %d - ",l); // longest period len
	     printf(" short %d - ",s); // shortest period len
	     // Pitfall-specific: Are all treasures in the
	     // same "group"; is there a path in the jungle
	     // which allows the play to grab all treasures?
	     l = c[0x28]; // 1st treasure: 00101000
	     s = 0;
	     m = 0;
	     for(q = 0; q <= MASK; q++) {
		z[c[q]]++; // Period length
		if((q & 0x38) == 0x28) { // Treasure room
			t[c[q]]++;
			if(t[c[q]] > s) {
				s = t[c[q]];
			}
			if(t[c[q]] == 1) { // treasure jungle
				m++; 
			}
		}
		if((q & 0x3a) == 0x20) { 
			k[c[q]]++; // Croc w/o vine
		}
		if((q & 0x38) == 0x28 && c[q] != l) {
			l = -1; // Multiple treasure "groups"
		}
	     }
	     printf("t: %d ",s); // max treasures in a jungle
	     printf("tj: %d ",m); // jungles w/ treasure
	     if(l != -1) {printf(" treasure ");
		if(c[0xc4] == l) {printf(" start ");}
	     }
	     for(q = 0; q <= MASK; q++) {
		printf("[%02x,%d]",q,c[q]);
		if(q < MASK) {printf(";");}
	     }
	     printf(" - ");
	     for(q = 0; q <= MASK; q++) {
		if(z[q] > 0) {
			printf("{%d,%d,%d,%d} ",
	q,z[q],t[q],k[q]); // Perm #, rooms, treasures, crocs
		}
	     }
	     printf("\n");
	} else {
	     // Sbox should be invertible, we should *never* 
	     // get here ("Garden of Eden": A state of a
	     // system we can never get to but can leave
	     // from)
	     printf(
		 "%d %d has Garden of Eden number(s)\n",a,b);
	}	
}

main(int argc, char **argv) {
	int a, seed, period, n;
	uint8_t *sbox;

	sbox = 0;
	n = 0;
	if(argc == 2) {
		n = atoi(argv[1]);
	}
	sbox = make_xar_sbox(0x0a10,n,3);
	stdout_sbox(sbox);
	view_cycles(sbox);
	return 0;
	for(seed = 0; seed < 65536; seed++) {
		//sbox = make_sbox(seed);
		//sbox = make_xar_sbox(seed,n,1);
		//sbox = make_galois_lfsr_sbox(seed,7);
		stdout_sbox(sbox);
		view_cycles(sbox);
		a = 1;
		period = 0;
		do {
			a = sbox[a];
			period++;
		} while(a != 1 && period < 256);
		printf("Period: %d\n",period);
		if(sbox != 0) {
			free(sbox);
			sbox = 0;
		}
	}
}
